/*
*
*     control
*       0 0    beq
*       0 1    bne
*       1 0    bltz and bgez
*
*  The branch condition for beq and bne depends on
*  the zero result for v = r[rs] - r[rt].
*
*  The branch condition for bltz and bgez is based
*  on ds = the sign bit of rs. In this case the lowest
*  order bit of the rt field (bit16 of the instruction)
*  determines which branch is executed.
*
*  branch is 1 if the branch is to be taken.
*/

module branch_control(control,branch,zero,rt,ds);
input zero;
input rt, ds; 
input [1:0] control;
output branch;

assign branch = (control[1]? (rt? !ds: ds): (control[0]? !zero: zero));

endmodule